package com.starbuds.server.service.net;

import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;

import java.net.InetAddress;
import java.net.UnknownHostException;

/**
 * Springboot 入口
 *
 * @author Lay
 * @date 2020/6/4
 */
@SpringBootApplication
@Slf4j
public class Application {
    public static void main(String[] args) {
        System.setProperty("app.name", "service-net");
        try {
            System.setProperty("hostname", InetAddress.getLocalHost().getHostName());
        } catch (UnknownHostException e) {
            System.setProperty("hostname", System.getProperty("app.name"));
        }
        SpringApplication.run(Application.class, args);
        log.info("[service-net] started.");
    }
}
